unit fruadressliste;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, ExtCtrls, StdCtrls, Grids, Graphics,
  Dialogs, LCLProc, Menus, Types, cuadresse, cukontakt, fuadresseditor, fukontakteditor;

type
  { TfrAdressliste }

  TfrAdressliste = class(TFrame)
    btnEditAdresse: TButton;
    btnInsertAdresse: TButton;
    btnDeleteAdresse: TButton;
    btnSpeichern: TButton;
    btnVerwerfen: TButton;
    btnEditKontakt: TButton;
    Button1: TButton;
    dgAdresse: TDrawGrid;
    pmiSaveKontakt: TMenuItem;
    N21: TMenuItem;
    pmiEditKontakt: TMenuItem;
    pmiInsertKontakt: TMenuItem;
    N22: TMenuItem;
    pmiDeleteKontakt: TMenuItem;
    N12: TMenuItem;
    pmiBlank3: TMenuItem;
    pmiBlank4: TMenuItem;
    pmiDelete1: TMenuItem;
    pmiEdit1: TMenuItem;
    pmiNew1: TMenuItem;
    pmiSaveAdresse: TMenuItem;
    pmiNewAdresse: TMenuItem;
    N11: TMenuItem;
    pmiEditAdresse: TMenuItem;
    pmiDeleteAdresse: TMenuItem;
    mInsert: TMenuItem;
    mEdit: TMenuItem;
    mDelete: TMenuItem;
    pmiSave1: TMenuItem;
    pnlButtons: TPanel;
    pnlHeader: TPanel;
    pmAdresse: TPopupMenu;
    procedure btnDeleteAdresseClick(Sender: TObject);
    procedure btnEditAdresseClick(Sender: TObject);
    procedure btnInsertAdresseClick(Sender: TObject);
    procedure btnSpeichernClick(Sender: TObject);
    procedure btnVerwerfenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure dgAdresseDrawCell(Sender: TObject; aCol, aRow: integer; aRect: TRect; aState: TGridDrawState);
    procedure dgAdresseSelectCell(Sender: TObject; aCol, aRow: integer; var CanSelect: boolean);
    procedure FrameResize(Sender: TObject);
    procedure pmAdressePopup(Sender: TObject);
  private
    A: TAdresse;
    FAdresse: TAdresse;
    FHasInfo: boolean;
    FOnFertig: TNotifyEvent;
    fCol, fRow: integer;

    procedure SetAdresse(AValue: TAdresse);
    procedure SetHasInfo(Avalue: boolean);
    procedure SetOnFertig(AValue: TNotifyEvent);
  public
    procedure InitGridAdresse;

    property HasInfo: boolean read FHasInfo write SetHasInfo;
    property OnFertig: TNotifyEvent read FOnFertig write SetOnFertig;
    property Adresse: TAdresse read FAdresse write SetAdresse;
  protected
    function GetAdressIndex: integer;
    function GetCellText(ACol, ARow: integer): string;
  end;

implementation

{$R *.frm}

{ TfrAdressliste }

{ dgAdresse Zeichnen }
procedure TfrAdressliste.dgAdresseDrawCell(Sender: TObject; aCol, aRow: integer; aRect: TRect; aState: TGridDrawState);
var
  txt: string;
  TextStyle: TTextStyle;
begin
  { Zellinhalt Holen }
  txt := GetCellText(ACol, ARow);
  { Spalte Fett }
  if Acol = 2 then
    dgAdresse.Canvas.Font.Style := [fsBold];

  { Farben setzen }
  if A.IDColor > 0 then

    if (aCol > 0) and (aRow >= dgAdresse.FixedRows) then
    begin
      if AState * [gdFocused, gdSelected] <> [] then
      begin
        dgAdresse.Canvas.Font.Color := StringToColor(A.Colorhfont);
        dgAdresse.Canvas.Brush.Color := StringToColor(A.Colorh);
      end
      else
      begin
        dgAdresse.Canvas.Font.Color := StringToColor(A.Colornfont);
        dgAdresse.Canvas.Brush.Color := StringToColor(A.Colorn);
      end;
    end;

  { Textstyle definieren }
  if aRow = 0 then
    TextStyle.Alignment := taCenter
  else
    case ACol of
      0: TextStyle.Alignment := taCenter;
      1: TextStyle.Alignment := taCenter; //Anrede
      2: TextStyle.Alignment := taLeftJustify; // Name
      3: TextStyle.Alignment := taLeftJustify; // Vorname
      4: TextStyle.Alignment := taLeftJustify; // Firma
      5: TextStyle.Alignment := taLeftJustify;      // Zusatz
      6: TextStyle.Alignment := taCenter;      // PLZ
      7: TextStyle.Alignment := taLeftJustify;// Ort
      8: TextStyle.Alignment := taLeftJustify;// Straße
    end;
  TextStyle.Layout := tlCenter;
  TextStyle.SingleLine := True;
  TextStyle.Clipping := True;
  TextStyle.ExpandTabs := True;
  TextStyle.ShowPrefix := True;
  TextStyle.Wordbreak := True;
  TextStyle.Opaque := False;
  TextStyle.SystemFont := False;
  TextStyle.RightToLeft := False;
  TextStyle.EndEllipsis := False;

  dgAdresse.Canvas.FillRect(ARect);
  InflateRect(ARect, -varCellpadding, -varCellpadding);   // Rechteck kleiner machen
  dgAdresse.Canvas.TextRect(ARect, ARect.Left + constCellPadding, ARect.Top + constCellPadding, txt, TextStyle);
end;

procedure TfrAdressliste.dgAdresseSelectCell(Sender: TObject; aCol, aRow: integer; var CanSelect: boolean);
begin
  //Dummy für Setfocus
end;

procedure TfrAdressliste.FrameResize(Sender: TObject);
begin
  InitGridAdresse;
end;

procedure TfrAdressliste.pmAdressePopup(Sender: TObject);
var
  mp: TPoint;
  cs: boolean;
begin

  mp := dgAdresse.ScreenToClient(Mouse.CursorPos);
  dgAdresse.MouseToCell(mp.x, mp.y, fCol, fRow);

  dgAdresse.Row := fRow;
  dgAdresse.Col := fCol;
  cs := True;
  dgAdresseSelectCell(self, fCol, fRow, cs);
end;

{ dgAdresse Initialisieren }
procedure TfrAdressliste.InitGridAdresse;
var
  v: integer;
begin
  { Einstellungen DrawGrid }
  dgAdresse.Colcount := dgAdresse.FixedCols + 8; // Wert an GetCellText anpassen!

  dgAdresse.RowCount := Adressliste.Count + dgAdresse.FixedRows;
  dgAdresse.Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine, goRowSelect, goSmoothScroll, goRowHighlight];
  dgAdresse.ScrollBars := ssVertical;
  dgAdresse.FixedCols := 1;
  dgAdresse.FixedRows := 1;
  v := (dgAdresse.Width - 15 - 920) div 6; { 1 variable Spalte v }
  dgAdresse.ColWidths[0] := 30;   // Width 715
  dgAdresse.ColWidths[1] := 100;  // Anrede
  dgAdresse.ColWidths[2] := 150 + v;  // Name
  dgAdresse.ColWidths[3] := 100 + v;  // Vorname
  dgAdresse.ColWidths[4] := 150 + v;  // Firma
  dgAdresse.ColWidths[5] := 150 + v;  // Zusatz
  dgAdresse.ColWidths[6] := 60;  // PLZ
  dgAdresse.ColWidths[7] := 80 + v;  // Ort
  dgAdresse.ColWidths[8] := 100 + v;  // Straße
end;

{ GridIndex Adresse Holen }
function TfrAdressliste.GetAdressIndex: integer;
begin
  Result := dgAdresse.Row - dgAdresse.FixedRows;
end;

{ Adressauswahl Beenden }
procedure TfrAdressliste.btnSpeichernClick(Sender: TObject);
var
  idx: integer;
begin
  idx := GetAdressIndex;
  if idx < 0 then
    exit;
  SetAdresse(Adressliste[idx]);
  if Assigned(FOnFertig) then
    FHasInfo := True;
  FOnFertig(Sender);
  exit;
end;

{ Adressauswahl Verwerfen }
procedure TfrAdressliste.btnVerwerfenClick(Sender: TObject);
begin
  if Assigned(FOnFertig) then
    FHasInfo := False;
  FOnFertig(Sender);
  exit;
end;

procedure TfrAdressliste.Button1Click(Sender: TObject);
begin
  AdressListe.WriteCSV('/home/klaus/test.csv');
end;

{ AdressEditor zum Editieren Starten }
procedure TfrAdressliste.btnEditAdresseClick(Sender: TObject);
var
  i, idx: integer;
  aID, Aindex: integer;
begin
  idx := GetAdressIndex;
  if idx < 0 then
    exit;
  A := Adressliste[idx];
  aID := CallAdressEditor(A);

  Adressliste.ReadAll;
  Aindex := Adressliste.IndexOf(aID);
  if AIndex >= 0 then
    dgAdresse.Row := AIndex + dgAdresse.FixedRows;
end;

{ Adresse Löschen inkl. Kontakten }
procedure TfrAdressliste.btnDeleteAdresseClick(Sender: TObject);
var
  idx: integer;
begin
  idx := GetAdressIndex;
  if idx < 0 then
    exit;
  if MessageDlg('Diese Adresse wirklich löschen?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    A := Adressliste[idx];
    Adressliste.DeleteByID(A.ID);
    Adressliste.Delete(idx);
    dgAdresse.RowCount := dgAdresse.RowCount - 1;
    if idx >= Adressliste.Count then
      idx := Adressliste.Count - 1;
    dgAdresse.Row := dgAdresse.FixedRows + idx;
    dgAdresse.Invalidate;
  end;
end;

{ AdressEditor zum Erstellen Starten }
procedure TfrAdressliste.btnInsertAdresseClick(Sender: TObject);
var
  aID, Aindex: integer;
begin
  aID := CallNewAdressEditor;
  if aID > 0 then
  begin
    Adressliste.ReadAll;
    dgAdresse.RowCount := dgAdresse.FixedRows + Adressliste.Count;
    dgAdresse.Invalidate;
    Aindex := Adressliste.IndexOf(aID);
    if AIndex >= 0 then
      dgAdresse.Row := AIndex + dgAdresse.FixedRows;
  end;
end;

{ dgAdresse Daten Einlesen }
function TfrAdressliste.GetCellText(ACol, ARow: integer): string;
begin
  if ARow = 0 then
  begin
    case ACol of
      0: Result := '';
      1: Result := 'Anrede';
      2: Result := 'Name / Firma';
      3: Result := 'Vorname';
      4: Result := 'Firma 2. Zeile';
      5: Result := 'Zusatz';
      6: Result := 'PLZ';
      7: Result := 'Ort';
      8: Result := 'Straße';
    end;
    //dgAdresse.SetFocus;   // Darf nicht aktiv sein, da sonst mit dgKontakt eine Rekursion gestartet wird!
  end
  else
  if Adressliste.Count > 0 then
  begin
    A := Adressliste[ARow - dgAdresse.FixedRows];
    if A = nil then
      Result := ''
    else
      case ACol of
        0: Result := IntToStr(ARow);
        1: Result := A.Anrede;
        2: Result := A.FirmaZuname;
        3: Result := A.Vorname;
        4: Result := A.Firma2;
        5: Result := A.Zusatz;
        6: Result := A.Plz;
        7: Result := A.Ort;
        8: Result := A.StrasseNr;
      end;
  end;
end;

procedure TfrAdressliste.SetHasInfo(Avalue: boolean);
begin
  if FHasInfo = AValue then
    Exit;
  FHasInfo := AValue;
end;

procedure TfrAdressliste.SetAdresse(AValue: TAdresse);
begin
  if FAdresse = AValue then
    Exit;
  FAdresse := AValue;
end;

procedure TfrAdressliste.SetOnFertig(AValue: TNotifyEvent);
begin
  if FOnFertig = AValue then
    Exit;
  FOnFertig := AValue;
end;

end.
